#!/usr/bin/python3
#
# DOI2BIB it's a Python3 script to resolve DOI numbers into BibTeX entries.
# It's relied on the doi.org exposed API.
# 
# It Follows closely the post https://scipython.com/blog/doi-to-bibtex/
# 
# Author: N. Biocca <biocca.nicolas@gmail.com>

import sys
import argparse

def request_doi(doi):
    '''
    request_doi: request doi to dx.doi.org

    input:
        doi          string
    
    ouput:
        error code   integer
        bibitem      string

    '''
    import urllib.request
    from urllib.error import HTTPError
    
    BASE_URL = 'http://dx.doi.org/'
    
    url = BASE_URL + doi
    req = urllib.request.Request(url)
    req.add_header('Accept', 'application/x-bibtex')
    try:
        with urllib.request.urlopen(req) as f:
            bibitem = f.read().decode()
            status_code = f.status
    except HTTPError as e:
        status_code = e.code
        bibitem = None
        if e.code == 404:
            print('info: DOI not found (from request_doi function).')
        else:
            print('info: Service unavailable (from request_doi function).')
    return status_code, bibitem

# 
# Parse command line arguments
# 
msg = """
Python script to resolve DOI numbers into BibTeX entries.
It uses the exposed API by doi.org.

Author: N. Biocca <biocca.nicolas@gmail.com>
"""
parser = argparse.ArgumentParser(
    description=msg,
    formatter_class=argparse.RawTextHelpFormatter
    )

parser.add_argument('-doi,--doi-number', nargs='+',default=[],help='Specify list of doi numbers',dest='doi_list')
parser.add_argument('--output-file',type=str,help='Specify output file (optionally)',default=None,dest='output_file')
parser.add_argument('--input-file',type=str,help='Specify input file with DOI items',default=None,dest='input_file')

args = parser.parse_args()

DOI_LIST = args.doi_list
OUTPUT_FILE = args.output_file
INPUT_FILE = args.input_file

#
# read DOIs from INPUT_FILE
# 
if INPUT_FILE is not None:
    print(f'info: Reading DOI number from {INPUT_FILE}...')
    try:
        with open(INPUT_FILE,'r') as inF:
            DOI_LIST = inF.readlines()
        DOI_LIST = [doi.strip() for doi in DOI_LIST]
        print(f'done.\n')      
    except FileNotFoundError:
        print(f"info: filename {INPUT_FILE} doesn't exist")
        print(f'info: exit')
        sys.exit(1)


#
# open OUTPUT_FILE and print header as a comment.
#  
if OUTPUT_FILE is not None:
    PRINT_SCREEN = False
    f = open(OUTPUT_FILE,'w')
    # print header
    f.write('% file automatically generated by doi2bib python script\n')
    f.write('% Author: N. Biocca <biocca.nicolas@gmail.com>\n')
    f.write('\n')
else:
    PRINT_SCREEN = True

failure_doi = []
failure_code = []

for doi in DOI_LIST:
    
    status_code, bibitem = request_doi(doi)

    if status_code == 200:    # success
        if PRINT_SCREEN:
            print(bibitem)
            print('\n')
        else:
            f.write(bibitem)
            f.write('\n\n')
    else:
        if PRINT_SCREEN:
            print(f'info: response failed')
            print(f'doi:{doi} ; status:{status_code}')
        else:
            f.write(f'% doi:{doi}\n')
            f.write(f'% status:{status_code}\n')
            f.wrte('\n\n')
        
        # store failures to report them in the end.
        failure_doi.append(doi)
        failure_code.append(status_code)

# close opened file 
if OUTPUT_FILE is not None:
    f.close()
    
#
# print final statistics
#  
print('# Final report:')
if len(failure_doi) == 0:
    msg = 'All DOI numbers were parsed successfully'
    print(msg)
else:
    msg = "The following DOI weren't parsed succefully:"
    print(msg)
    for doi, error_code in zip(failure_doi,failure_code):
        print(f'doi:{doi} ; error code:{error_code}')
